/*
 * MC35_Steuerung.c
 *
 * Created: 28.06.2011 16:24:08
 *  Author: sTEk
 
 
 * LED-Blink-Codes (in ms > an/aus/an/aus...)
 * LED_rot:
		500/500			-	Initialisierungsphase
		
 * LED_gelb:
		1000			-	Empfang: okay
		850/150			-	Empfang: mau
		350/350			-	Empfang: kein oder sehr schlecht
		150/150			-	Empfang: Fehler
 
 */ 

#include "definitionen.h"

int16_t timer_zaehler = 0;

volatile int16_t timer_wartezeit_befehl = 0;
volatile int16_t timer_wartezeit_normal = 0;
volatile int16_t timer_wartezeit_blink_gelb = 0;
volatile int16_t timer_wartezeit_blink_gruen = 0;

volatile int32_t timer_wartezeit_empfang = 0;


volatile int16_t timer_wartezeit_taster_wasser = 0;
volatile int16_t timer_wartezeit_taster_gardena = 0;


volatile su8_Byte_Regiter_Bits_1_S1 stati_Taster;
volatile su8_Byte_Regiter_Bits_1_S1 stati_Ausgang;
/**/


int8_t timer_on = 0;
int8_t led_rot = 0;



//alle 1ms gehts hier rein
ISR (TIMER0_COMP_vect)
{	
	
	//Status der gelben LED
	if(timer_wartezeit_blink_gelb > 0)
	{
		timer_wartezeit_blink_gelb--;
		if(timer_wartezeit_blink_gelb == 0 && (stati_S2.empfang1 == 0 || stati_S2.empfang2 == 0))
		{
			if(stati_S2.empfang2 == 1)
			{
				if(stati_S2.empfang_kipper == 0)
				{
					timer_wartezeit_blink_gelb = 1450;
				}
				else
				{
					timer_wartezeit_blink_gelb = 550;
				}					
			}
			else if(stati_S2.empfang1 == 1)
			{
				if(stati_S2.empfang_kipper == 0)
				{
					timer_wartezeit_blink_gelb = 1850;
				}
				else
				{
					timer_wartezeit_blink_gelb = 150;
				}					
			}
			else
				timer_wartezeit_blink_gelb = 250;
		
			stati_S2.led_gelb = 1;
		}
	}	
	
	
	if (stati_S1.fehler == 1)
	{
		timer_wartezeit_blink_gelb++;
		timer_zaehler++;
		
		if(timer_wartezeit_blink_gelb == 500)
		{
			stati_S2.led_gelb = 1;
			stati_S2.led_rot = 1;
			timer_zaehler = 0;
			timer_wartezeit_blink_gelb = 0;
		}
		
	}
	
	
	//Status der roten LED
	//Initialisierung und kein Betriebsmodus > Fehler
	if(betriebsmodus == 0 && stati_S1.init == 1)
	{
		timer_zaehler++;
		if(timer_zaehler == 500)
		{
			timer_zaehler = 0;
			stati_S2.led_rot = 1;
		}
	}

	if(timer_wartezeit_blink_gruen > 0)
	{
		timer_wartezeit_blink_gruen--;
		if(timer_wartezeit_blink_gruen == 0)
		{
			stati_S2.led_gruen = 1;
		}
	}		



	
	if(timer_wartezeit_empfang > 0)
		timer_wartezeit_empfang--;
	if(timer_wartezeit_empfang == 0 && stati_S1.init == 0 && betriebsmodus == 0)
	{
		modem_Abfragen_Empfang();
	}
	
	
	if(timer_wartezeit_normal > 0)
	{
		timer_wartezeit_normal--;
	
		if (timer_wartezeit_normal == 0)
		{
			uart_putc(0x0d);
		}
	}

	
	if(betriebsmodus>0 && stati_S1.lauschen == 0)
	{
		timer_wartezeit_befehl++;
		if(timer_wartezeit_befehl == 5000)
		{
			betriebsmodus = 0;
			timer_wartezeit_befehl = 0;
		}

	}	
	
	if(stati_Taster.wasser == 1)
	{
		timer_wartezeit_taster_wasser++; //hier gibts jetzt Probleme...nur warum??
	}
}






ISR(USART_TXC_vect)
{
		UART_RTS_ON;
};






int main(void)
{

	LEDGRUEN_LO;
	LEDGELB_LO;
	LEDROT_LO;
	stati_S1.i1_o = 0;
	stati_S1.i2_o = 0;
	stati_S1.i3_o = 0;
	
	//stati_Ausgang = 0;
	//stati_Taster = 0;
	
	ports_definieren();
	vInit_USART();
	timer();

	stati_S1.lauschen |= 1;

	sei();
	
	
	
	
	modem_init();
/*		stati_S1.i1_o = 1;
		stati_S1.i2_o = 1;
		stati_S1.i3_o = 1;
		stati_S1.i4_o = 1;
		modem_Abfragen_Empfang();
*/
    
	
	while(1)
    {
		if(stati_S1.init == 1 && timer_wartezeit_befehl == 0)
			modem_init();


		if(stati_S1.init == 1 && betriebsmodus == 101)
			LEDROT_HIGH;
		else
			LEDROT_LO;
			

		if(stati_S2.empfang1 == 1 && stati_S2.empfang2 == 1)
			LEDGELB_HIGH;

		if(stati_S2.led_gelb == 1)
		{
			stati_S2.led_gelb = 0;
			toggle_led_gelb();
		}

		if(stati_S2.led_rot == 1)
		{
			stati_S2.led_rot = 0;
			toggle_led_rot();
		}

		if(stati_S2.led_gruen == 1)
		{
			stati_S2.led_gruen = 0;
			toggle_led_gruen();
		}


		//Tasterberprfung
/*		if( !(PORTA & 1<<PA5))
		{
			stati_Taster.wasser = 1;
		}
		else
			stati_Taster.wasser = 0;
*/		

	}	
}