/*
 * at_steuerung.c
 *
 * Created: 28.06.2011 16:51:20
 *  Author: sTEk
 */ 

#include "definitionen.h"


volatile uint8_t betriebsmodus = 0;
volatile uint8_t kommando[24];
volatile uint8_t vergleich[16];
volatile int16_t timer_wartezeit_normal;
volatile uint8_t nummer_eingehend[16];

int8_t kommando_laenge = 0;

volatile su8_Byte_Regiter_Bits_S1 stati_S1;
volatile su8_Byte_Regiter_Bits_S2 stati_S2;

volatile nummern telefonnummern[10] =
								{
								{'9', '9', '9', '9', '9', '9', '9', '9', '9', '9', '9'},
								{'9', '9', '9', '9', '9', '9', '9', '9', '9', '9', '8'}
								};

int8_t nummern_anzahl = 2;

/*

		betriebsmodus:
			101 ..  Initialisierungsphase
			102 ..	Empfang abfragen
			
			
			0	..	normaler Lauf - Warten auf Anruf/SMS
			1	..	Anruf kommt rein
			2	..	SMS kam rein
			
			
			10	..	Initialisierungsphase
			20	..	Anruferphase - Anrufer erkannt



*/

void uart_put_kommando (uint8_t *s, int8_t counter)
{
	stati_S1.lauschen = 0;
   while (counter != 0)
    {   /* so lange *s != '\0' also ungleich dem "String-Endezeichen" */
        uart_putc(*s);
		counter--;
        s++;
    }
	timer_wartezeit_normal = 250;
}




void modem_init()
{
	timer_wartezeit_befehl = 0;
		betriebsmodus = 101;
	stati_S1.init = 1;
		kommando[0] = 'A';
		kommando[1] = 'T';
		kommando[2] = '+';

	//Hardwareflusssteuerung: ein
	if(stati_S1.i1_o == 0)
	{
		
		kommando[2] = '\\';
		kommando[3] = 'Q';
		kommando[4] = '3';
		kommando_laenge = 5;
		uart_put_kommando(kommando, kommando_laenge);
		return;
	}

	if(stati_S1.i2_o == 0)
	{
		
		kommando[3] = 'C';
		kommando[4] = 'L';
		kommando[5] = 'C';
		kommando[6] = 'K';
		kommando[7] = 0x3d;
		kommando[8] = 0x22;
		kommando[9] = 'S';
		kommando[10] = 'C';
		kommando[11] = 0x22;
		kommando[12] = ',';
		kommando[13] = '0';
		kommando[14] = ',';
		kommando[15] = '9';
		kommando[16] = '9';
		kommando[17] = '9';
		kommando[18] = '9';
		kommando_laenge = 19;
		uart_put_kommando(kommando, kommando_laenge);
		return;
	}



	//GSM 07.05 Phase 2+: ein
	if(stati_S1.i3_o == 0)
	{
		
		kommando[3] = 'C';
		kommando[4] = 'S';
		kommando[5] = 'M';
		kommando[6] = 'S';
		kommando[7] = 0x3d;
		kommando[8] = '1';
		kommando_laenge = 9;
		uart_put_kommando(kommando, kommando_laenge);
		return;
	}

	//SMS-Format: Text
	if(stati_S1.i4_o == 0)
	{
		
		kommando[3] = 'C';
		kommando[4] = 'M';
		kommando[5] = 'G';
		kommando[6] = 'F';
		kommando[7] = 0x3d;
		kommando[8] = '1';
		kommando_laenge = 9;
		uart_put_kommando(kommando, kommando_laenge);
		return;
	}
	
	//SMS-Benachrichtigung: sofort reagieren und anzeigen/benachrichtigen
	if(stati_S1.i5_o == 0)
	{
		
		kommando[3] = 'C';
		kommando[4] = 'N';
		kommando[5] = 'M';
		kommando[6] = 'I';
		kommando[7] = 0x3d;
		kommando[8] = '2';
		kommando[9] = ',';
		kommando[10] = '2';
		kommando[11] = ',';
		kommando[12] = '2';
		kommando[13] = ',';
		kommando[14] = '1';
		kommando_laenge = 15;
		uart_put_kommando(kommando, kommando_laenge);
		return;
	}

}


void modem_Abfragen_Empfang()
{
		betriebsmodus = 102;
		timer_wartezeit_befehl = 0;
		kommando[0] = 'A';
		kommando[1] = 'T';
		kommando[2] = '+';
		kommando[3] = 'C';
		kommando[4] = 'S';
		kommando[5] = 'Q';
		kommando_laenge = 6;
		uart_put_kommando(kommando, kommando_laenge);
		return;
}

void modem_Abfragen_Anrufer()
{
		betriebsmodus = 1;
		timer_wartezeit_befehl = 0;
		kommando[0] = 'A';
		kommando[1] = 'T';
		kommando[2] = '+';
		kommando[3] = 'C';
		kommando[4] = 'L';
		kommando[5] = 'C';
		kommando[6] = 'C';
		kommando_laenge = 7;
		uart_put_kommando(kommando, kommando_laenge);
		return;
}

void modem_Abweisen_Anrufer()
{
		betriebsmodus = 2;
		timer_wartezeit_befehl = 0;
		kommando[0] = 'A';
		kommando[1] = 'T';
		kommando[2] = '+';
		kommando[3] = 'C';
		kommando[4] = 'H';
		kommando[5] = 'U';
		kommando[6] = 'P';
		kommando_laenge = 7;
		uart_put_kommando(kommando, kommando_laenge);
		return;
}

int8_t Ausw_Kommando()
{
	if(stati_S1.i1_o == 1)
		stati_S1.i1_o = 1;
	for (int8_t i = 0; i < kommando_laenge; i++)
	{
		if(kommando[i] != uart_string[i])
			return 0;
	}
	return 1;
}

int8_t Ausw_Antwort(int8_t modus)
{
	int8_t counter = 0;
	if(modus == 0)
	{
		vergleich[0] = 'O';
		vergleich[1] = 'K';
		counter = 2;
	}
	else if(modus == 1)
	{
		vergleich[0] = '+';
		vergleich[1] = 'C';
		vergleich[2] = 'S';
		vergleich[3] = 'Q';
		vergleich[4] = ':';
		counter = 5;
	}
	
	else if(modus == 10)
	{
		vergleich[0] = '+';
		vergleich[1] = 'C';
		vergleich[2] = 'L';
		vergleich[3] = 'C';
		vergleich[4] = 'C';
		vergleich[5] = ':';
		counter = 6;
	}

	else if(modus == 100)
	{
		vergleich[0] = 'R';
		vergleich[1] = 'I';
		vergleich[2] = 'N';
		vergleich[3] = 'G';
		counter = 4;
	}
	
	else if(modus == 101)
	{
		vergleich[0] = '+';
		vergleich[1] = 'C';
		vergleich[2] = 'M';
		vergleich[3] = 'T';
		counter = 4;
	}
	
	else if(modus == 11)
	{
		vergleich[0] = 'E';
		vergleich[1] = 'R';
		vergleich[2] = 'R';
		vergleich[3] = 'O';
		vergleich[4] = 'R';
		counter = 5;
	}
	
		
	for (int8_t i = 0; i < counter; i++)
	{
		if(vergleich[i] != uart_string[i])
			return 0;
	}
	return 1;
}


int8_t Ausw_Telefonnummer()
{
	int8_t ueber = 0;
	for(int8_t i = 0; (i < nummern_anzahl); i++)
	{
		
		for (int8_t j = 0; j < 11; j++)
		{
			ueber = 1;
			if(telefonnummern[i].nu[j] != nummer_eingehend[j])
			{
				ueber = 0;
				break;
			}				
		}
		if(ueber == 1)
			return 1;
	}
	return 0;
}

int8_t Ausw_Sms()
{
	vergleich[0] = '0';
	vergleich[1] = '8';
	vergleich[2] = '1';
	vergleich[3] = '5';

	for (int8_t i = 0; i < 4; i++)
	{
		if(vergleich[i] != uart_string[i])
			return 0;
	}
	return 1;
}


void Auswertung()
{
	uint8_t l = uart_str_count;
	int8_t roger = 0;

	//Leerzeile, da 0xd nicht in den Ziel-UART-String geschrieben wird
	if (uart_str_count == 0)
	{
		return;
	}

	//auf ein Kommando wird dieses immer in voller Lnge wiederholt
	//wenn nicht gelauscht wird, dann wird auf die Wiederholung des Kommandos gewartet
	if(stati_S1.lauschen == 0)
	{
		if (Ausw_Kommando() == 1)
		{
			stati_S1.lauschen = 1;
		}
		return;
	}
	
	//der Befehl wurde bereits wiederholt, es muss also eine Antwort kommen
	// Leerzeile
	// Antwort
	// Leerzeile
	// OK
	// 0x0a
	if(betriebsmodus > 100)
	{
		//Initialisierungsphase
		if(betriebsmodus == 101)
		{
			//auf Befehle kommt status und dann okay
			if(uart_str_count < 3)
			{
				//einfache Auswertung...alle Anweisungen mssen 'OK' ergeben
				if (Ausw_Antwort(0) == 1)
				{
					kommando_laenge = 0;
					betriebsmodus = 0;
					
					if(stati_S1.i1_o == 0)
						stati_S1.i1_o = 1;
					else if(stati_S1.i2_o == 0)
						stati_S1.i2_o = 1;
					else if(stati_S1.i3_o == 0)
						stati_S1.i3_o = 1;
					else if(stati_S1.i4_o == 0)
						stati_S1.i4_o = 1;
					else if(stati_S1.i5_o == 0)
					{
						stati_S1.i5_o = 1;
						stati_S1.init = 0;
						modem_Abfragen_Empfang();
						return;
					}						
					modem_init();
				}
			}
			else if(Ausw_Antwort(11) == 1) //ERROR
			{
				stati_S1.init = 0;
				stati_S1.fehler = 1;
				stati_S2.fehler_kipper = 1;
				timer_wartezeit_blink_gelb = 499;
			}
			return;
		}
		
		//Empfang auswerten
		if(betriebsmodus == 102)
		{
			if(uart_str_count < 3)
			{
				//Ende des Befehls erreicht
				if(Ausw_Antwort(0) == 1)
					betriebsmodus = 0;
			}
			
			
			else if (Ausw_Antwort(1) == 1)
			{
				timer_wartezeit_blink_gelb = 50;
				int8_t temp1 = 6;
				int8_t temp2 = 0;
				while(uart_string[temp1] != ',')
				{
					temp2++; 
					temp1++;
				}
				//in temp2 steht dann der RSSI-Wert
				if(temp2 == 2)
					temp2 = ((uart_string[temp1-2]-0x30)*10) + (uart_string[temp1-1]-0x30);
				else
					temp2 = (uart_string[temp1-1]-0x30);
				
					
				//kein bzw. kaum Empfang
				if(temp2 == 0 || temp2 == 1)
				{
					stati_S2.empfang1 = 0;
					stati_S2.empfang2 = 0;
				}
				//mieser Empfang
				else if(temp2 < 18)
				{
					stati_S2.empfang1 = 1;
					stati_S2.empfang2 = 0;
				}
				//halbwegs Empfang
				else if(temp2 < 31)
				{
					stati_S2.empfang1 = 0;
					stati_S2.empfang2 = 1;
				}
				//guter Empfang
				else
				{
					stati_S2.empfang1 = 1;
					stati_S2.empfang2 = 1;
					timer_wartezeit_blink_gelb = 0;
				}
			}
			else
			{
				timer_wartezeit_blink_gelb = 50;
				stati_S2.empfang1 = 0;
				stati_S2.empfang2 = 0;
			}
			timer_wartezeit_empfang = 0x2BF20; //3 Minuten bei 1ms Timer
		}
		
		
		
	}
	//Abfragen nach Anruf
	else if(betriebsmodus == 1)
	{

		if(uart_str_count < 3)
		{
			//Ende des Befehls erreicht == OK
			if(Ausw_Antwort(0) == 1)
			{
				betriebsmodus = 0;
				modem_Abweisen_Anrufer();

				if (Ausw_Telefonnummer() == 1)
				{
					timer_wartezeit_blink_gruen = 500;
					stati_S2.led_gruen = 1;
				}			

			}				
		}


		//Telefonnummer abfragen
		else if (Ausw_Antwort(10) == 1)
		{
			
			int8_t temp1 = 6;
			int8_t temp2 = 0;	//Kommazhler
			int8_t temp3 = 0;
			while(temp2 < 6)
			{
				temp1++;
				if(uart_string[temp1] == ',')
				{
					temp2++;
					if(temp2 == 5)
						temp3 = temp1+2;	//Kommastelle plus vorderes " der Nummernanzeige
				}
			}
			//wenn mit Lnderkennung, diese ignorieren
			if(uart_string[temp3] == 0x2b)
					temp3+=3;
			temp1 --;						//hinteres " der Nummernanzeige
			
			temp2 = 0;
			//Telefonnummer auslesen
			for(temp3; temp3 < temp1; temp3++)
			{
				
				nummer_eingehend[temp2] = uart_string[temp3];
				temp2++;
			}
		}
	}		
	
	else if(betriebsmodus == 2)
	{
		if(uart_str_count < 3)
		{
			//Ende des Befehls erreicht
			if(Ausw_Antwort(0) == 1)
				betriebsmodus = 0;
		}
	}

	//SMS kam rein
	else if(betriebsmodus == 3)
	{
		//Sms hatte richtigen Inhalt > 0815
		if(Ausw_Sms() == 1)
		{
			betriebsmodus = 0;
			timer_wartezeit_blink_gruen = 500;
			stati_S2.led_gruen = 1;
		}
	}



	else
	{
		//Anruf
		if (Ausw_Antwort(100) == 1)
		{
			modem_Abfragen_Anrufer();
					
		}

		//Anruf
		if (Ausw_Antwort(101) == 1)
		{
			betriebsmodus = 3;
					
		}
	}		

}