/*
 * definitionen.h
 *
 * Created: 24.06.2011 16:47:06
 *  Author: sTEk
 */ 

#ifndef EXTERN
#define EXTERN extern
#endif

#ifndef F_CPU
/* In neueren Version der WinAVR/Mfile Makefile-Vorlage kann
   F_CPU im Makefile definiert werden, eine nochmalige Definition
   hier wuerde zu einer Compilerwarnung fuehren. Daher "Schutz" durch
   #ifndef/#endif 
 
   Dieser "Schutz" kann zu Debugsessions fhren, wenn AVRStudio 
   verwendet wird und dort eine andere, nicht zur Hardware passende 
   Taktrate eingestellt ist: Dann wird die folgende Definition 
   nicht verwendet, sondern stattdessen der Defaultwert (8 MHz?) 
   von AVRStudio - daher Ausgabe einer Warnung falls F_CPU
   noch nicht definiert: */
#warning "F_CPU war noch nicht definiert, wird nun nachgeholt mit 16000000"
#define F_CPU 16000000UL  // Systemtakt in Hz - Definition als unsigned long beachten 
#endif



#include <avr/io.h>
#include <stdint.h>
#include <avr/interrupt.h>
#include "at_steuerung.h"
#include "hw_setup.h"
#include "uart.h"



#ifndef DEFINITIONEN_H_
#define DEFINITIONEN_H_




#define LEDROT_LO			PORTA &= ~0x1
#define LEDROT_HIGH			PORTA |= 0x1
#define LEDGELB_LO			PORTA &= ~0x2
#define LEDGELB_HIGH		PORTA |= 0x2
#define LEDGRUEN_LO			PORTA &= ~0x4
#define LEDGRUEN_HIGH		PORTA |= 0x4

#define REGEN_LO			PORTA &= ~0x10
#define REGEN_HIGH			PORTA |= 0x10
#define WASSER_LO			PORTA &= ~0x20
#define WASSER_HIGH			PORTA |= 0x20


#define UART_RTS_ON			PORTD &= (~1 << PD2)
#define UART_RTS_OFF		PORTD |= (1 << PD2)



#define erststart			0




	typedef struct su8_Byte_Regiter_Bits_1
	{
		INT8U	wasser	:1;
		INT8U 	zeit	:1;
		INT8U	fehler	:1;
		INT8U	i5_o	:1;
		INT8U	i4_o	:1;
		INT8U	i3_o	:1;
		INT8U	i2_o	:1;
		INT8U	i1_o	:1;
	}su8_Byte_Regiter_Bits_1_S1;

extern volatile su8_Byte_Regiter_Bits_1_S1 stati_Taster;
extern volatile su8_Byte_Regiter_Bits_1_S1 stati_Ausgang;





extern volatile int16_t timer_wartezeit_befehl;
extern volatile int16_t timer_wartezeit_normal;
extern volatile int32_t timer_wartezeit_empfang;

extern volatile int16_t timer_wartezeit_blink_gelb;
extern volatile int16_t timer_wartezeit_blink_gruen;

extern volatile int16_t timer_wartezeit_taster_wasser;
extern volatile int16_t timer_wartezeit_taster_gardena;


#endif /* DEFINITIONEN_H_ */