/*
 * uart.c
 *
 * Created: 24.06.2011 16:52:45
 *  Author: sTEk
 */ 

//extern unByte_Register unByteRegister;

#include "definitionen.h"


volatile uint8_t uart_str_complete = 0;
volatile unsigned char uart_string[UART_MAXSTRLEN + 1];
volatile uint8_t uart_str_count = 0;



void vInit_USART(void)
{
	
	
    UBRRH = (uint8_t) (UBRR_VAL>>8);
    UBRRL = (uint8_t) (UBRR_VAL);
 
	UCSRC = (1 << URSEL)|(1 << UCSZ0)|(1 << UCSZ1);
	UCSRB = (1 << TXEN)|(1 << RXEN)|(1 << TXCIE)|(1 << RXCIE);
	UCSRA = (1 << U2X);


    // Flush Receive-Buffer (entfernen evtl. vorhandener ungltiger Werte) 
    do
    {
        UDR;
    }
    while (UCSRA & (1 << RXC));

	uart_str_complete = 0;
	uart_str_count = 0;

	UART_RTS_ON;
 
}



int uart_putc(unsigned char c)
{
//	UART_RTS_ON;
    while (!(UCSRA & (1<<UDRE)))  /* warten bis Senden moeglich */
    {
    }                             
 
    UDR = c;                      /* sende Zeichen */
//	UART_RTS_OFF;
    return 0;
}
 
 
/* puts ist unabhaengig vom Controllertyp */
void uart_puts (char *s)
{
    while (*s)
    {   /* so lange *s != '\0' also ungleich dem "String-Endezeichen" */
        uart_putc(*s);
        s++;
    }
}




ISR(USART_RXC_vect)
{
	UART_RTS_OFF;
	
	unsigned char nextChar;
 
	// Daten aus dem Puffer lesen
	nextChar = UDR;


	if(nextChar != 0x0a)
	{
		if ( nextChar == 0x0d || uart_str_count >= (UART_MAXSTRLEN - 1) )
		{
			Auswertung();
			uart_str_count = 0;
			uart_str_complete = 0;
			
		}
			// Daten werden erst in string geschrieben, wenn nicht String-Ende/max Zeichenlnge erreicht ist/string gerade verarbeitet wird
		else 
		{
				uart_string[uart_str_count] = nextChar;
				uart_str_count++;
		}
	}		
	  
	UART_RTS_ON;
	
};