/*
 * uart.h
 *
 * Created: 24.06.2011 16:49:30
 *  Author: sTEk
 */ 


#ifndef UART_H_
#define UART_H_



 
#define BAUD 19200UL      // Baudrate
#define DoubleSpeed 1
#define UART_MAXSTRLEN		48


// Berechnungen
#if (DoubleSpeed == 1)
	#define U_temp_Multi  8
#else
	#define U_temp_Multi  16
#endif	

#define UBRR_VAL ((F_CPU/(BAUD*U_temp_Multi))-1)   // clever runden
#define BAUD_REAL (F_CPU/(U_temp_Multi*(UBRR_VAL+1)))     // Reale Baudrate
#define BAUD_ERROR ((BAUD_REAL*1000)/BAUD) // Fehler in Promille, 1000 = kein Fehler.

 
#if ((BAUD_ERROR<990) || (BAUD_ERROR>1010))
  #error Systematischer Fehler der Baudrate groesser 1% und damit zu hoch! 
#endif 



extern void uart_puts(char *s);
extern void vInit_USART(void);
extern int uart_putc(unsigned char c);


extern volatile uint8_t uart_str_complete;
extern volatile uint8_t uart_str_count;
extern volatile unsigned char uart_string[UART_MAXSTRLEN + 1];




#endif /* UART_H_ */